import { IConfiguration } from './../model/configuration';
export declare class ServiceConfiguration<T> {
    /**
     * Select default path for service configuraiton path in different environment
     * By default Backtrace expect to run service from root service directory
     * by using npm commands. In environment different than production
     * @ServiceConfiguration class will read configuration file from root dir.
     * Otherwise from default Backtrace configuration directory
     */
    getProjectSettingsPath(serviceName: string): string;
    /**
     * Loads service configuration file
     */
    loadConfiguration(configurationPath: string): IConfiguration<T>;
}
