const { service } = require('./service-layer');

const config = service.configuration;

const metrics = {
  tenant: {},
  totalSuccesses: 0,
  totalFailures: 0,
};

const resetMetrics = () => {
  metrics.tenant = {};
  metrics.totalSuccesses = 0;
  metrics.totalFailures = 0;
};

const samlSuccess = (hostname) => {
  if (metrics.tenant[hostname]) {
    metrics.tenant[hostname].success += 1;
  } else {
    metrics.tenant[hostname] = {
      success: 1,
      failure: 0,
    };
  }
  metrics.totalSuccesses += 1;
};

const samlFailure = (hostname) => {
  if (metrics.tenant[hostname]) {
    metrics.tenant[hostname].failure += 1;
  } else {
    metrics.tenant[hostname] = {
      success: 0,
      failure: 1,
    };
  }
  metrics.totalFailures += 1;
};

const getMetrics = (req, res) => {
  const token = req.query.token;
  const metricsToken = config.bind['metrics-token'];
  if (metricsToken && metricsToken === token) {
    res.status(200).json(metrics);
    resetMetrics();
  } else {
    res.status(400).json({ message: 'invalid metrics token' });
  }
};

module.exports = {
  samlSuccess,
  samlFailure,
  getMetrics,
};
